/****** Object:  Table [dbo].[WHD]    Script Date: 08/08/2011 16:35:06 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[WHD](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[ParentID] [int] NULL,
	[Free] [nvarchar](50) NULL,
	[refid] [int] NULL,
 CONSTRAINT [PK_WHD] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[WHD]  WITH CHECK ADD  CONSTRAINT [FK_WHD_WHD] FOREIGN KEY([ParentID])
REFERENCES [dbo].[WHD] ([ID])
GO

ALTER TABLE [dbo].[WHD] CHECK CONSTRAINT [FK_WHD_WHD]
GO

CREATE TABLE [dbo].[Ref](
	[ID] [int] NULL,
	[Name] [nvarchar](50) NULL
) ON [PRIMARY]

GO

INSERT INTO [dbo].[Ref] (ID, Name) VALUES (1,'ref1')
INSERT INTO [dbo].[Ref] (ID, Name) VALUES (2,'ref2')

GO

-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[sp_SELECT_whd_level]
	@level int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    	WITH TEMP
		AS
		(
			SELECT P.*,
					0 as [Level]
			FROM WHD AS P
			WHERE ParentID IS NULL

			UNION ALL

			SELECT C.*, 
					P.[Level] + 1 AS [Level]
			FROM WHD AS C
			INNER JOIN TEMP AS P ON C.ParentID = P.ID

		)
		SELECT *
		From TEMP
		WHERE Level = @level
END

GO

